local M = {}

local dissolvedVehicles = {false, false, false, false}
local loaded = false

local classEvent = require('scenario/cargames/classEvent')

local function checkAcid(vehicleObject, name, id)
	--[[
	Checks to see if a vehicle has entered the acid and if so, explodes it/ends scenario
	]]--
	if vehicleObject:getPosition().y > -711 and vehicleObject:getPosition().z < 9.5 then
		vehicleObject:queueLuaCommand('fire.explodeVehicle()')
		vehicleObject:queueLuaCommand('beamstate.breakAllBreakgroups()')
		--If the player has triggered this, then they have failed
		if name == "scenario_player0" then
			classEvent.updateEvent("fail", "Your car has been dissolved!")
		--If an opponent has triggered this, prevent them from scoring anything
		elseif name:find("opponent") then
			classEvent.updateEvent("forceScore", name, 0)
		end

		--Set this to prevent this function looping
		if id then
			dissolvedVehicles[id] = true
		end
	end
end

local function onPreRender(dt)
	--Prevents this function running when the objects so not exists, causing errors
	if loaded then
		--Continously check for vehicles entering acid, if they haven't already
		--The scenario will end when the player fails the scenario by entering the acid, so does the same thing
		if not classEvent.callMethod("isFinished") then checkAcid(scenetree.findObject("scenario_player0"), "scenario_player0", nil) end
		if not dissolvedVehicles[1] then checkAcid(scenetree.findObject('opponent0'), "opponent0", 1) end
		if not dissolvedVehicles[2] then checkAcid(scenetree.findObject('opponent1'), "opponent1", 2) end
		if not dissolvedVehicles[3] then checkAcid(scenetree.findObject('truck1'), "truck1", 3) end
		if not dissolvedVehicles[4] then checkAcid(scenetree.findObject('truck2'), "truck2", 4) end
	end
end

local function onRaceStart()
	loaded = true
end

M.onRaceStart = onRaceStart
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M
