local M = {}

local classEvent = require('scenario/cargames/classEvent')
local particleHandler = require('scenario/cargames/particleMotion')

local particles = {["lava1_angle"] = 0, ["lava1_radius"] = 275, ["lava1_z"] = 430, ["lava2"] = 751, ["lava3_y"] = 868, ["lava3_z"] = 576, ["lava4_y"] = 868, ["lava4_z"] = 576}

local function updateParticles()
	--[[
	Updates the position of the particles
	]]--
	particles["lava1_angle"] = particles["lava1_angle"] + 0.1*bullettime.get()

	--Volcano particle
	if particles["lava1_radius"] > 10 then
		particles["lava1_radius"] = particles["lava1_radius"] - 0.5*bullettime.get()
		particles["lava1_z"] = particles["lava1_z"] + 0.5*bullettime.get()
	else
		particles["lava1_radius"] = 275
		particles["lava1_z"] = 430
	end

	x_1, y_1 = particleHandler.circular(particles["lava1_radius"], particles["lava1_angle"])

	--Bottom left particle
	particles["lava2"] = particles["lava2"] - 5*bullettime.get()
	if particles["lava2"] < 176 then particles["lava2"] = 751 end

	--Top right particle
	particles["lava3_y"] = particles["lava3_y"] + 3*bullettime.get()
	if particles["lava3_y"] > 206 then
		particles["lava3_y"] = -868
		particles["lava3_z"] = 576
	elseif particles["lava3_y"] > -400 then
		particles["lava3_z"] = particles["lava3_z"] - math.sin(20)
	end

	--Top left particle
	particles["lava4_y"] = particles["lava4_y"] + 3*bullettime.get()
	if particles["lava4_y"] > 206 then
		particles["lava4_y"] = -868
		particles["lava4_z"] = 576
	elseif particles["lava4_y"] > -400 then
		particles["lava4_z"] = particles["lava4_z"]-math.sin(20)
	end

	TorqueScript.eval([[
		lava1.position = "]]..(-1101+x_1)..[[ ]]..(584+y_1)..[[ ]]..particles["lava1_z"]..[[";
		lava2.position = "-655.852783 ]]..particles["lava2"]..[[ 435.763428";
		lava3.position = "-448 ]]..particles["lava3_y"]..[[ ]]..particles["lava3_z"]..[[";
		lava4.position = "-724 ]]..particles["lava4_y"]..[[ ]]..particles["lava4_z"]..[[";
	]])
end

local function onBeamNGTrigger(data)
	if data.event == "enter" then
		if string.find(data.triggerName, 'fallen') then
			local playerObject = scenetree.findObject("scenario_player0")
			playerObject:queueLuaCommand('fire.explodeVehicle()')
			playerObject:queueLuaCommand('beamstate.breakAllBreakgroups()')
			classEvent.updateEvent("fail", "You fell off the course!")
		end
	end
end

local function onPreRender(dt)
	if bullettime.get() > 0 then
		updateParticles()
	end
end

M.onPreRender = onPreRender
M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
M.onRaceTick = onRaceTick
return M
