--This event is too different from the curling event class so will be a stand alone, non-implemented version

local M = {}

local helper = require('scenario/scenariohelper')
local scenarioTimeOut = 0
local startTimer  = false
local turn1, turn2 = 0, 0
local pendData = ''
local rotation = 0
local player1Finished = false
local finished = false
local start = false
local statisticsHandler = require('scenario/cargames/statisticsHandler')
local eventHandler = require('scenario/cargames/eventHandler')
local uiHandler = require('scenario/cargames/uiHandler')

local function finish(score, turn1, turn2)
	--[[
	Ends the scenario
	]]--
	finished = true
	eventHandler.endScenario({event = "curling", theme = 5, name = "Theme 5:2| Car Curling: Duality",  scores = {total = score, scoreTurnA = turn1, scoreTurnB = turn2}})
end

local function updateLevel()
	--[[
	Updates the level with the blocked off previous path taken
	]]--
	if pendData == 'way1' then
		TorqueScript.eval('way1barrier.position = "-547.344 -751.424988 0";')
	elseif pendData == 'way2' then
		TorqueScript.eval('way2barrier.position = "-592.088 -789.186 1.25766";')
	elseif pendData == 'way3' then
		TorqueScript.eval('way3barrier.position = "-562.56 -751.067 2.82749";')
	elseif pendData == 'way4' then
		TorqueScript.eval('way4barrier.position = "-543.292 -785.608 3.22146";')
	end

	be:reloadStaticCollision();
	pendData = ''
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'ice' then
		helper.queueLuaCommandByName("scenario_player0", 'bullettime.set(4)')
		startTimer = true
	elseif string.match(data.triggerName, 'way') and not player1Finished then
		pendData = data.triggerName
	end
end

local function calcScore(turn)
	--[[
	Calculates the score for the turn
	]]--
	local playerObject = scenetree.findObject("scenario_player0")
	local distance = math.floor(math.sqrt(math.pow(playerObject:getPosition().x+563.3, 2) + math.pow(playerObject:getPosition().y+733.6, 2) + math.pow(playerObject:getPosition().z+0.01, 2)))
	local score = math.max(0, 100-distance*2)
	uiHandler.updateMedalUI("curling", 5, nil, false, score)
	if     turn == 1 then
		turn1 = score
	elseif turn == 2 then
		turn2 = score
	end
end

local function handleTurn()
	--[[
	Handles the turn
	]]--
	if startTimer and not player1Finished then
		calcScore(1)
		updateLevel()
		TorqueScript.eval('scenario_player0.position = "-561.110962 -1000.08478 0.221231461";')
		TorqueScript.eval('scenario_player0.rotation = "0 0 -1 0";')
		player1Finished = true
		startTimer = false
		scenarioTimeOut = 0
		helper.queueLuaCommandByName("scenario_player0", 'bullettime.set(1)')
	elseif player1Finished then
		calcScore(2)
		finish(math.max(0, turn1+turn2), turn1, turn2)
	end
end

local function onRaceStart()
	start = true
end

local function onScenarioChange(sc)
	if sc.state == 'pre-running' then
		uiHandler.updateMedalUI("curling", 5, nil, false, nil)
		uiHandler.updateTimerUI(scenarioTimeOut, 5)

		helper.queueLuaCommandByName("scenario_player0", 'bullettime.set(1)')
		TorqueScript.eval([[
			way1barrier.position = "10000 0 0";
			way2barrier.position = "10000 0 0";
			way3barrier.position = "10000 0 0";
			way4barrier.position = "10000 0 0";
		]])
		be:reloadStaticCollision();
	end
end

local function onPreRender(dt)
	rotation = rotation + dt*100*bullettime.get()
	TorqueScript.eval('rotor.rotation = "1 0 0 '..rotation..'";')

	if not finished and start then
		if startTimer then
			scenarioTimeOut = scenarioTimeOut + dt*bullettime.get()
			scenetree.findObject("scenario_player0"):queueLuaCommand('obj:setWind(0, 0, 0)')
		else
			scenetree.findObject("scenario_player0"):queueLuaCommand('obj:setWind(0, 150, 0)')
		end

		uiHandler.updateTimerUI(scenarioTimeOut, 5)

		if scenarioTimeOut >= 5 then
			handleTurn()
		end
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onRaceStart = onRaceStart
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M
