--This event is too different from the darts event class so will be a stand alone, non-implemented version

local M = {}

local rotorRotation = 0
local sawRotation = 0
local angle = 0
local distance = 0
local multiplier = 1
local scoring = false
local finished = false
local timeOut = 0
local uiHandler = require('scenario/cargames/uiHandler')
local eventHandler = require('scenario/cargames/eventHandler')

local function onScenarioChange(sc)
	if sc.state == 'pre-running' then
		uiHandler.updateMedalUI("darts", 5, nil, false)
		uiHandler.updatePowerups(nil, {{type = "x2", id = "1"}, {type = "x2", id = "2"}, {type = "x2", id = "3"}, {type = "x2", id = "4"}, {type = "x2", id = "5"}}, true)

		scenetree.findObject("scenario_player0"):queueLuaCommand('obj:setWind(0, 0, 0)')
		TorqueScript.eval([[
		x2_1_board.position = "-581.63855 -554.020264 384.264801";
		x2_2_board.position = "-566.567261 -752.592957 264.948975";
		x2_3_board.position = "-569.114807 -466.943481 226.544952";
		x2_4_board.position = "-513.750977 -641.771667 472.160706";
		x2_5_board.position = "-618.940918 -666.757202 502.487213";
		]])
	end
end

local function success(scr)
	scoring = false
	finished = true

	local score = math.max(0, scr*multiplier)

	local multipliers = {}
	while multiplier > 1 do
		table.insert(multipliers, 2)
		multiplier = multiplier/2
	end

	eventHandler.endScenario({event = "darts", theme = 5, name = "Theme 5:1| Car Darts: Gearing Up For More", scores = {scoreFinalPosition = scr, total = score, multipliers = multipliers}})
end

local function onBeamNGTrigger(data)
	if string.find(data.triggerName, 'steam') then
		if     data.event == 'enter' then scenetree.findObject("scenario_player0"):queueLuaCommand('obj:setWind(0, 555, 0)')
		elseif data.event == 'exit'  then scenetree.findObject("scenario_player0"):queueLuaCommand('obj:setWind(0, 0, 0)')
		end
	elseif scoring and not finished then
		if string.find(data.triggerName, 'target') then
			success(tonumber(string.match(data.triggerName, "%d+")))
		end
	elseif string.find(data.triggerName, 'x2') and data.event == 'enter' then
		TorqueScript.eval(''..data.triggerName..'_board.position = "10000";')
		multiplier = multiplier*2

		local name = data.triggerName:gsub("_", "")
		uiHandler.updatePowerups(name, nil, nil)
	end
end

local function updateParticles(theta, dt)
	local x, y = 20*math.cos(theta*dt*100*bullettime.get()), 20*math.sin(theta*dt*100*bullettime.get())
	TorqueScript.eval([[
	steamCannon1.position = "]]..(-614.218323+x)..[[ -786.179443 ]]..(499.290192+y)..[[";
	steamCannon2.position = "]]..(-507.492462+x)..[[ -786.179443 ]]..(514.696472+y)..[[";
	]])
end

local function onPreRender(dt)
	if bullettime.get() > 0 then
		rotorRotation = rotorRotation + dt*100*bullettime.get()
		sawRotation = sawRotation + 0.5*dt*100*bullettime.get()
		TorqueScript.eval([[
		rotor1.rotation =  "1 0  0 ]]..rotorRotation..[[";
		rotor2.rotation =  "1 0  0 ]]..rotorRotation..[[";
		rotor3.rotation =  "1 0  0 ]]..rotorRotation..[[";
		rotor4.rotation =  "1 0  0 ]]..rotorRotation..[[";
		rotor7.rotation =  "0 0 -1 ]]..rotorRotation..[[";
		rotor8.rotation =  "0 0 -1 ]]..rotorRotation..[[";
		rotor9.rotation =  "0 0 -1 ]]..rotorRotation..[[";
		rotor10.rotation = "0 0 -1 ]]..rotorRotation..[[";
		rotor11.rotation = "0 0 -1 ]]..rotorRotation..[[";
		rotor12.rotation = "0 0 -1 ]]..rotorRotation..[[";
		rotor13.rotation = "0 0 -1 ]]..rotorRotation..[[";
		saw1.rotation = "1 0 0 ]].. sawRotation..[[";
		saw2.rotation = "1 0 0 ]]..-sawRotation..[[";
		saw3.rotation = "1 0 0 ]].. sawRotation..[[";
		saw4.rotation = "1 0 0 ]]..-sawRotation..[[";
		saw5.rotation = "1 0 0 ]].. sawRotation..[[";
		saw6.rotation = "1 0 0 ]].. sawRotation..[[";
		saw7.rotation = "1 0 0 ]].. sawRotation..[[";
		saw8.rotation = "1 0 0 ]].. sawRotation..[[";
		]])

		angle = angle + dt*2
		updateParticles(angle, dt)
	end
end

local function onRaceTick(raceTickTime)
	local scenario_playerData = map.objects[map.objectNames["scenario_player0"]]
	if scenario_playerData.vel:length() <= 0.075 and not scoring then
		scoring = true
	elseif scoring and not finished then
		timeOut = timeOut+raceTickTime
		if timeOut > 3 then
			success(0)
		end
	end
end

M.onScenarioChange = onScenarioChange
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onPreRender = onPreRender
return M
