--Best =

local M = {}

local rotation = 0

local classEvent = require('scenario/cargames/classEvent')

local function onBeamNGTrigger(data)
	if string.find(data.triggerName, 'saw') then
		if data.subjectName == "scenario_player0" then
			if data.event == 'enter' then
				--Gets the saw number which will correlate to the speed of the saw
				local number = tonumber(string.match(data.triggerName, "%d+"))
				local cmd = ''
				--Saws 3 and 5 rotate in the opposite direction
				if number == 3 or number == 5 then
					cmd = 'obj:setWind(0, '..(-300-number*50)..', 0)'
				else
					cmd = 'obj:setWind(0, '..(300+number*50)..', 0)'
				end

				scenetree.findObject("scenario_player0"):queueLuaCommand(cmd)
			else
				--If the player has exitted the trigger, stop wind
				scenetree.findObject("scenario_player0"):queueLuaCommand('obj:setWind(0, 0, 0)')
			end
		elseif data.event == 'enter' then
			--A ball has entered the saw and so has been destroyed
			classEvent.updateEvent("destoryBall", data.subjectName)
		end
	end
end

local function onPreRender(dt)
	if bullettime.get() > 0 then
		rotation = rotation + dt*100*bullettime.get()
		TorqueScript.eval([[
			saw_obj1.rotation = " 1 0 0 ]].. rotation   ..[[";
			saw_obj2.rotation = " 1 0 0 ]]..(rotation*2)..[[";
			saw_obj3.rotation = "-1 0 0 ]]..(rotation*3)..[[";
			saw_obj4.rotation = " 1 0 0 ]]..(rotation*4)..[[";
			saw_obj5.rotation = "-1 0 0 ]]..(rotation*5)..[[";

			saw_bg_1.rotation =  " 1 0 0 ]].. rotation   ..[[";
			saw_bg_2.rotation =  "-1 0 0 ]]..(rotation*1.5)..[[";
			saw_bg_3.rotation =  " 1 0 0 ]].. rotation   ..[[";
			saw_bg_4.rotation =  "-1 0 0 ]]..(rotation*1.25)..[[";
			saw_bg_5.rotation =  " 1 0 0 ]].. rotation   ..[[";
			saw_bg_6.rotation =  " 1 0 0 ]]..(rotation*2)..[[";
			saw_bg_7.rotation =  " 1 0 0 ]].. rotation   ..[[";
			saw_bg_8.rotation =  "-1 0 0 ]]..(rotation*1.75)..[[";
			saw_bg_9.rotation =  " 1 0 0 ]].. rotation   ..[[";
			saw_bg_10.rotation = "-1 0 0 ]]..(rotation*1.125)..[[";
			saw_bg_11.rotation = " 1 0 0 ]].. rotation   ..[[";
			saw_bg_12.rotation = "-1 0 0 ]]..(rotation*1.625)..[[";
		]])
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onPreRender = onPreRender
return M
