local M = {}

local classEvent = require("scenario/cargames/classEvent")
local start = false

local function onScenarioChange(sc)
	if sc.state == "pre-running" then
		classEvent.updateEvent("onScenarioChange", sc)
		classEvent.createNewEvent(sc.sourceFile)

		--Hide the floor
    local ground = scenetree.findClassObjects('Groundplane')
    for _, name in ipairs(ground) do
      scenetree.findObject(name).hidden = true
    end

    start = true
	end
end

local function onScenarioRestarted()
	classEvent.updateEvent("onScenarioRestarted")
end

local function onBeamNGTrigger(data)
	classEvent.updateEvent("onBeamNGTrigger", data)
end

local function onRaceTick(rtt)
	classEvent.updateEvent("onRaceTick", rtt)
end

local function onRaceStart()
	classEvent.updateEvent("onRaceStart")
end

local function onPreRender(dt)
	if start then
    classEvent.updateEvent("onPreRender", dt)
  end
end

M.onScenarioChange = onScenarioChange
M.onScenarioRestarted = onScenarioRestarted
M.onBeamNGTrigger = onBeamNGTrigger
M.onRaceTick = onRaceTick
M.onRaceStart = onRaceStart
M.onPreRender = onPreRender
return M
