local M = {}

Gem = {}
Gem.__index = Gem

function Gem:new(position, id)
  local instance = {center = position, id = id, animation = {angle = 0}}

  TorqueScript.eval([[
			new TSStatic(gem]]..id..[[) {
			  shapeName = "levels/smallgridspace/art/shapes/campaign/medals/gem.dae";
        position = "]]..position.x..[[ ]]..position.y..[[ ]]..position.z..[[";
			  //collisionType = "Visible Mesh Final";
			  //decalType = "Visible Mesh Final";
		  };
	]])

  setmetatable(instance, Gem)
  return instance
end

function Gem:destroy()
  --[[
  Destorys itself
  ]]--
  self = nil
end

function Gem:collect(scenarioData)
  --[[
  Removes the gem from the world and asks the fileHandler to write to file about it
  Also destorys itself
  ]]--
  TorqueScript.eval('gem'..self.id..".delete();")
  fileHandler.setAttributeToSave({name = "gem", theme = scenarioData.theme, event = scenarioData.event, value = true})
  self:destory()
end

function Gem:animate()
  --[[
  Animates via bobbing
  ]]--
  if bullettime.get() > 0 then
    local amplitude = math.sin(math.rad(self.animation.angle))
    local newPosition = {x = self.center.x, y = self.center.y, z = self.center.z + amplitude}

    TorqueScript.eval('gem'..self.id..'.position = "'..newPosition.x..' '..newPosition.y..' '..newPosition.z..'";')

    self.animation.angle = self.animation.angle+(dt*60)
  end
end

function Gem:update(scenarioData, dt)
  --[[
  Updates the gem, such as check if player has got close enough to achieve it as
  well as animating it
  ]]--
  --Animate
  self:animate()

  --Check if the player has got close enough to collect the gem
  local vehicleObject = scenetree.findObject("scenario_player0")
  local distance = math.floor(math.sqrt(math.pow(vehicleObject:getPosition().x-self.center.x, 2) + math.pow(vehicleObject:getPosition().y-self.center.y, 2) + math.pow(vehicleObject:getPosition().z-self.center.z, 2)))
  if distance <= 5 then
    self:collect(scenarioData)
  end
end

-----------------------------------------------------------------------------------------------------------------------------------

local function createGem(args)
  return Gem:new(args.position, args.id)
end

M.createGem = createGem
return M
