--Not used currently

local characterDimensions = {
	["A"] = 24.66,
	["B"] = 20.59,
	["C"] = 21.34,
	["D"] = 20.61,
	["E"] = 18.70,
	["F"] = 16.85,
	["G"] = 22.99,
	["H"] = 19.65,
	["I"] = 4.960,
	["J"] = 15.73,
	["K"] = 22.17,
	["L"] = 17.30,
	["M"] = 23.74,
	["N"] = 19.50,
	["O"] = 23.77,
	["P"] = 18.83,
	["Q"] = 24.66,
	["R"] = 22.10,
	["S"] = 19.78,
	["T"] = 19.53,
	["U"] = 19.60,
	["V"] = 22.69,
	["W"] = 32.26,
	["X"] = 21.31,
	["Y"] = 22.99,
	["Z"] = 17.99,
	["0"] = 15.96,
	["1"] = 10.80,
	["2"] = 16.52,
	["3"] = 16.18,
	["4"] = 17.87,
	["5"] = 16.53,
	["6"] = 16.42,
	["7"] = 16.11,
	["8"] = 16.16,
	["9"] = 16.42,
	[" "] = 0.000,
}

local function createText(input)
	local characters = {}
	--Remove spaces for filenames
	local filename = input:gsub(' ', '')

	for i = 1, #input do
		--Find character in string
		local c = string.upper(input:sub(i, i))

		if c ~= ' ' then
			if scenetree.findObject('Text_'..filename) ~= nil then
				TorqueScript.eval('Text_'..filename..'.delete();')
			end
			TorqueScript.eval([[
				new TSStatic(Text_]]..filename..'_'..i..[[) {
				  shapeName = "levels/smallgrid/art/shapes/cargames/alphanumeric/arial/]]..c..[[.dae";
				  scale = "1 1 1";
				};
			]])
		end

		table.insert(characters, {["Alphanumeric"] = c, ["PosX"] = characterDimensions[c]})
	end

	return characters
end

local function createUnit(name, input)
	if scenetree.findObject('Text_'..name..'_'..input) ~= nil then
		TorqueScript.eval('Text_'..name..'_'..input..'.delete();')
	end

	TorqueScript.eval([[
		new TSStatic(Text_]]..name..'_'..input..[[) {
		  shapeName = "levels/smallgrid/art/shapes/cargames/alphanumeric/units/]]..input..[[.dae";
		  scale = "1000 1000 1000";
		};
	]])
end

---------------------------------------------------------------------------------------------------------------------
--Class Text--
---------------------------------------------------------------------------------------------------------------------

Text = {}
Text.__index = Text

function Text:new(name, id, x, y, z, rotation, scale)
	local self = {}
	setmetatable(self, Text)
	self.tempTable = {["Length"] = 0, ["Text"] = '', ["Id"] = 0}
	self.str = name
	self.id = id
	self.x = x
	self.y = y
	self.z = z
	self.r = rotation
	self.s = scale
	return self
end

function Text:deleteText()
	--Remove pre-existing text
	for i = 1, self.tempTable["Length"] do
		TorqueScript.eval('Text_'..self.tempTable["Text"]..'_'..i..'.delete();')
	end

	if self.tempTable["Text"] ~= '' then TorqueScript.eval('Text_'..(self.tempTable["Text"]..self.tempTable["Id"])..'.delete();') end
end

function Text:placeText()
	--Get a table of the required chars
	local alphanum = createText(self.str..self.id)
	local spacing = 25*(self.s/5)
	local x = self.x
	local filename = self.str:gsub(' ', '')..self.id

	--Loop through string and place each alphanum char
	for i = 1, #self.str do
		if alphanum[i]["Alphanumeric"] ~= ' ' then
			TorqueScript.eval('Text_'..filename..'_'..i..'.position = "'..x..' '..self.y..' '..self.z..'";')
			TorqueScript.eval('Text_'..filename..'_'..i..'.rotation = "'..self.r[1]..' '..self.r[2]..' '..self.r[3]..' '..self.r[4]..'";')
			TorqueScript.eval('Text_'..filename..'_'..i..'.scale = "'..self.s..' '..self.s..' '..self.s..'";')
		end
		x = x-alphanum[i]["PosX"]*self.s-spacing
	end

	--Update tempTable to store various information for deleting next iteration
	self.tempTable["Length"] = #self.str
	self.tempTable["Text"] = self.str
	self.tempTable["Id"] = self.id
end

function Text:update()
	self:deleteText()
	self:placeText()
end

---------------------------------------------------------------------------------------------------------------------
--Main--
---------------------------------------------------------------------------------------------------------------------

local M = {}
local textInWorld = {}
local identity = 0

--Gets the length of the table T
local function getTableLength(t)
	local length = 0
	for _ in pairs(t) do length = length+1 end
	return length
end

--Deletes all text in the world
local function deleteTextInWorld()
	for i = 1, getLengthOfTable(textInWorld) do
		textInWorld[i]:deleteText()
	end
end

--Setups the text used in the simulation
local function setupText(text, x, y, z, rotation, scale)
	t = Text:new(text, identity, x, y, z-(500*0.015), rotation, scale)
	t:placeText()
	table.insert(textInWorld, t)
	identity = identity+1
end

M.setupText = setupText
M.deleteTextInWorld = deleteTextInWorld
return M
