angular.module('beamng.apps')
.directive('nitro', ['UiUnits', function (UiUnits) {
  return {
    template:
    '<div class="bngApp" style="width: 100%; height: 100%; font-size: 1.4em;" ' +
                'layout="column">' +
                '<span id="progressBar"; style="width: 0px; height: 50px; background-color: #0066ff; backgroundColor = "transparent";"></span>' +
    '</div>',
    replace: true,
    link: function (scope, element, attrs) {
      'use strict';

      scope.pulse = 1
      scope.pulseInc = 0.02

      function resetValues () {
        scope.$evalAsync(function () {
          scope.pulse = 1
          scope.pulseInc = 0.02
        });
      }

      scope.$on('nitroIndicator', function (event, data) {

        var progBar = document.getElementById("progressBar");
        var width = 500*(data.nitro);
        progBar.style.width = width + "px";

        progBar.style["background-color"] = "hsl(" + (120*data.nitro) + ", 100%, 50%)"

        if (data.active){
          if (scope.pulse >= 1){
            scope.pulseInc = -0.1
          } else if (scope.pulse <= 0.25){
            scope.pulseInc = 0.1
          }

          //Used so that different FPS result in same pulse frequency
          scope.pulse += scope.pulseInc*data.increment

          progBar.style.opacity = scope.pulse
        } else{
          if (progBar.style.opacity != 1){
            progBar.style.opacity = 1
          }
        }

        scope.$evalAsync(function () {

        });
      });

      scope.$on('ScenarioResetTimer', resetValues);
    }
  };
}]);
