angular.module('beamng.apps')
.directive('powerup', ['UiUnits', function (UiUnits) {
  return {
    template:
      '<div class="bngApp" id="powerupDiv" style="width: 100%; height: 100%; font-size: 1.4em;" ' +
                  'layout="column">' +
                  // '<span style="font-size: 90%; align: middle;"><img id="powerupImage1" src="modules/apps/Powerup/x2.png" style="width: 100px; height: 87px; align: middle;"></img>' +
                  // '<span style="font-size: 90%; align: middle;"><img id="powerupImage2" src="modules/apps/Powerup/x2.png" style="width: 100px; height: 87px; align: middle;"></img>' +
                  // '<span style="font-size: 90%; align: middle;"><img id="powerupImage3" src="modules/apps/Powerup/x2.png" style="width: 100px; height: 87px; align: middle;"></img>' +
      '</div>',
    replace: true,
    link: function (scope, element, attrs) {
      'use strict';

      function resetValues () {
        scope.$evalAsync(function () {
        });
      }

      scope.$on('powerupIndicator', function (event, data) {
        //Setups the powerups as greyed out
        if (data.initialise && data.initialise.length) {
          var htmlToAdd = ""
          for (var i = 0; i < data.initialise.length; i++) {
            var id = data.initialise[i]["id"];
            var typ = data.initialise[i]["type"];
            htmlToAdd += '<span style="font-size: 90%; align: middle;"><img id="powerupImage' + typ + id + '"; src="modules/apps/Powerup/' + typ + '.png" style="float: middle; width: 100px; height: 87px; opacity: 0.125;"></img>'
          }

          htmlToAdd += "</span>".repeat(data.initialise.length);
          document.getElementById('powerupDiv').innerHTML += htmlToAdd;
        }

        //Lighten image to show it has been triggered
        if (data.powerupTriggered) {
          document.getElementById("powerupImage" + data.powerupTriggered).style.opacity = 1;
        }

        scope.$evalAsync(function () {
        });
      });

      scope.$on('ScenarioResetTimer', resetValues);
    }
  };
}]);
