angular.module('beamng.apps')
.directive('scoring', ['UiUnits', function (UiUnits) {
  return {
    template:
      '<div class="bngApp" style="width: 100%; height: 100%; font-size: 2.5em; font-family: impact;" layout="column";>' +
                  '<span style="font-size: 90%; vertical-align: middle; align: right;"><img id="bestMedal" src="modules/apps/Scoring/none.png" style="width: 49px; height: 42px; vertical-align: middle; align: left;"></img>Best:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{{(scoringBestScore) || "---" }}</span>' +
                  '<span style="font-size: 90%; vertical-align: middle; align: right;"><img id="targetMedal" src="modules/apps/Scoring/none.png" style="width: 49px; height: 42px; vertical-align: middle; align: left;"></img>Target:&nbsp;&nbsp;&nbsp;&nbsp;{{(scoringTargetScore) || "---" }}</span>' +
                  '<span style="font-size: 90%; vertical-align: middle; align: right;"><img id="currentMedal" src="modules/apps/Scoring/none.png" style="width: 49px; height: 42px; vertical-align: middle; align: left;"></img>Current:&nbsp;{{(scoringScore) || "---" }}</span>' +
      '</div>',
    replace: true,
    link: function (scope, element, attrs) {
      'use strict';

      scope.scoringScore = "null";
      scope.medals = ["null", "null", "null"];

      function resetValues () {
        scope.$evalAsync(function () {
          scope.scoringScore = "null";
          scope.scoringTargetScore = "null";
          scope.scoringBestScore = "null";
          scope.medals = ["null", "null", "null"];
        });
      }

      scope.$on('scoringScore', function (event, data) {
        if(scope.medals[1] != data.target.medal) { document.getElementById("targetMedal").src=data.target.medal }
        if(scope.medals[2] != data.best.medal) { document.getElementById("bestMedal").src=data.best.medal }
        if(scope.medals[3] != data.current.medal) { document.getElementById("currentMedal").src=data.current.medal }

        scope.$evalAsync(function () {
          scope.scoringScore = data.current.score;
          scope.scoringTargetScore = data.target.score;
          scope.scoringBestScore = data.best.score;
          scope.medals = [];
        });
      });

      scope.$on('ScenarioResetTimer', resetValues);

      scope.$on('RaceLapChange', function (event, data) {

      });
    }
  };
}]);
